unit janCheckListButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons,checklst;

type
  TjanCheckListButton = class(TSpeedButton)
  private
    { Private declarations }
    // speedbutton controls a checkListbox
    // but this could really be any control
    FOnChecked:TNotifyEvent;
    FCheckList:TCheckListBox;
    FItems:TStringList;
    procedure CheckExit(sender:TObject);
    procedure SetItems(const Value: TstringList);
    procedure SetChecked(Index: Integer; Checked: Boolean);
    function GetChecked(Index: Integer): Boolean;
    procedure SetonChecked(const Value: TNotifyEvent);
    procedure doOnChecked(sender:TObject);
  protected
    { Protected declarations }
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);override;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    destructor  Destroy; override;
    procedure   Loaded; override;
    property Checked[Index: Integer]: Boolean read GetChecked write SetChecked;
  published
    { Published declarations }
    property Items:TstringList read FItems write SetItems;
    property onChecked:TNotifyEvent read FonChecked write SetonChecked;
  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents('janBasic', [TjanCheckListButton]);
end;

{ TjanCheckListButton }

constructor TjanCheckListButton.Create(AOwner: TComponent);
begin
  inherited;
  FCheckList:=TcheckListBox.Create(self);
  // set the onExit event so that when you click a control that can have focus
  // the CheckList will be hidden
  FcheckList.OnExit:=CheckExit;
  FCheckList.OnClickCheck:=doOnChecked;
  FItems:=TStringList.create;
end;

procedure TjanCheckListButton.Loaded;
begin
  inherited;
  // because TSpeedButton is not a TWinControl descendant we can not use CreateWnd
  FCheckList.parent:=getparentForm(self);
  FcheckList.visible:=false;
  FCheckList.items.Assign (FItems);
end;

destructor TjanCheckListButton.Destroy;
begin
  // this is some strange behaviour in Delphi
  // when a component has a parent as a form then form will try to destroy
  // this component when the form is destroyed,
  // even if the component is owned by another component
  // to avoid 'loose' Checklist we free the checklist when we remove our custom component
  // during design stage.
  FItems.Free;
  if (csDesigning in ComponentState) then
    FCheckList.free;
  inherited;

end;

procedure TjanCheckListButton.CheckExit(sender: TObject);
begin
   FCheckList.visible:=false;
end;

procedure TjanCheckListButton.MouseUp(Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var pt:TPoint;
    frm:TCustomform;
begin
  inherited;
  if FCheckList.Visible then
    FCheckList.visible:=false
  else
  begin
    // show the checkList beneath our custom control
    pt:=Clienttoscreen(point(0,0));
    frm:=getparentform(self);
    pt:=frm.ScreenToClient(pt);
    FcheckList.left:=pt.x;
    FcheckList.top:=pt.y+height;
    FcheckList.visible:=true;
    FcheckList.BringToFront;
  end;
end;

procedure TjanCheckListButton.SetItems(const Value: TstringList);
begin
  FItems.assign(value);
end;


function TjanCheckListButton.GetChecked(Index: Integer): Boolean;
begin
  result:=FCheckList.Checked[index];
end;

procedure TjanCheckListButton.SetChecked(Index: Integer; Checked: Boolean);
begin
  FcheckList.Checked[index]:=Checked;
end;

procedure TjanCheckListButton.SetonChecked(const Value: TNotifyEvent);
begin
  FonChecked := Value;
end;

procedure TjanCheckListButton.doOnChecked(sender: TObject);
begin
  if assigned(onChecked) then
    onChecked(sender);
end;

end.
