unit janLabelEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type

  TjanLabelEdit = class(TWinControl)
  private
    FMargin: integer;
    FStaticText: TStaticText;
    FEdit: TEdit;
    FLabelColor: Tcolor;
    procedure autofit;
    procedure SetMargin(const Value: integer);
    procedure SetCaption(const Value: string);
    function  GetCaption:string;
    procedure SetFont(const Value: TFont);
    function  getFont:TFont;
    procedure SetLabelFont(const Value: TFont);
    function  GetLabelFont:TFont;
    procedure SetText(const Value: string);
    function  GetText:string;
    procedure TextChanged(sender: TObject);
    procedure SetLabelColor(const Value: Tcolor);
    function  GetLabelcolor:Tcolor;
  protected
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMMove(var Message: TWMMove); message WM_MOVE;
    procedure CreateWnd;override;
  public
    constructor Create(AOwner:TComponent);override;
    destructor  Destroy; override;
  published
    property Margin:integer read FMargin write SetMargin;
    property Text:string read GetText write SetText;
    property Font:TFont read GetFont write SetFont;
    property Caption:string read GetCaption write SetCaption;
    property LabelFont:TFont read GetLabelFont write SetLabelFont;
    property LabelColor:Tcolor read GetLabelColor write SetLabelColor;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('janBasic', [TjanLabelEdit]);
end;


procedure TjanLabelEdit.WMSize(var Message: TWMSize);
begin
  inherited;
  autofit;
end;


procedure TjanLabelEdit.autofit;
begin
  FEdit.width:=width;
  FEdit.height:=height;
  FStaticText.top:=4;
  Fstatictext.Height :=height-8;
  FStaticText.Left := Width-FStaticText.width-FMargin;
  FEdit.Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FStaticText.Width+FMargin)*$10000);
end;



procedure TjanLabelEdit.SetMargin(const Value: integer);
begin
  FMargin:=value;
  autofit;
end;


//   edit1.Perform(EM_SETMARGINS,EC_RIGHTMARGIN,$00300000);

procedure TjanLabelEdit.WMMove(var Message: TWMMove);
begin
  inherited;
  autofit;
end;


constructor TjanLabelEdit.Create(AOwner: TComponent);
begin
  inherited;
  width:=121;
  height:=24;
  FEdit:=TEdit.Create (self);
  FEdit.parent:=self;
  FEdit.onchange:=TextChanged;
  FStaticText:=TStaticText.Create (self);
  FStatictext.parent:=Self;
  FStatictext.Caption:='Label';
  FStaticText.autosize:=true;
  FMargin:=4;
end;

destructor TjanLabelEdit.Destroy;
begin
  FEdit.free;
  FStaticText.free;
  inherited;

end;

procedure TjanLabelEdit.CreateWnd;
begin
  inherited;
  FEdit.width:=width;
  FEdit.height:=height;
  autofit;
end;

procedure TjanLabelEdit.SetCaption(const Value: string);
begin
  FStaticText.Caption := Value;
  autofit;
end;

procedure TjanLabelEdit.SetFont(const Value: TFont);
begin
  FEdit.Font.assign(Value);
end;

procedure TjanLabelEdit.SetLabelFont(const Value: TFont);
begin
  FStaticText.Font.assign(Value);
end;

procedure TjanLabelEdit.SetText(const Value: string);
begin
  FEdit.Text := Value;
  autofit;
end;

function TjanLabelEdit.GetCaption: string;
begin
  result:=FStatictext.caption;
end;

function TjanLabelEdit.getFont: TFont;
begin
  result:=FEdit.font;
end;

function TjanLabelEdit.GetLabelFont: TFont;
begin
  result:=FStatictext.font;
end;

function TjanLabelEdit.GetText: string;
begin
  result:=FEdit.text;
end;


procedure TjanLabelEdit.TextChanged(sender:Tobject);
begin
  FEdit.Perform(EM_SETMARGINS,EC_RIGHTMARGIN,(FStaticText.Width+FMargin)*$10000);
end;

procedure TjanLabelEdit.SetLabelColor(const Value: Tcolor);
begin
  FStatictext.Color := Value;
end;

function TjanLabelEdit.GetLabelcolor: Tcolor;
begin
  result:=FStaticText.color;
end;

end.
